-- **************************************************************************
-- * TitanTreasuryRightClick.lua
-- *
-- * By: KanadiaN
-- *       (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanTreasury", true );

-- **************************************************************************
-- NAME : TitanPanelRightClickMenu_PrepareTreasuryMenu()
-- DESC : Builds Right Click Interactive Menu
-- **************************************************************************
function TitanPanelRightClickMenu_PrepareTreasuryMenu()
     local cRealm = TitanTreasury_ColorUtils( "GetCFaction", TitanTreasuryProfile.Faction, TitanTreasuryProfile.Realm );
     local cDelete = TitanTreasury_ColorUtils( "GetCText", "RED", LB["TITAN_TREASURY_MENU_DELETE"] );
     TitanTreasury_DebugUtils( "Bug", "RightClickMenu", 18, ( "-> %s" ):format( UIDROPDOWNMENU_MENU_LEVEL ) );
     if ( UIDROPDOWNMENU_MENU_LEVEL == 2 and UIDROPDOWNMENU_MENU_VALUE == cRealm ) then
          TitanTreasury_DebugUtils( "Bug", "RightClickMenu", 20, ( "-> %s  ==  %s  -- %s" ):format( UIDROPDOWNMENU_MENU_VALUE, LB["TITAN_TREASURY_DEBUG_MDEBUG"], UIDROPDOWNMENU_MENU_LEVEL ) );
          -- Toon Data Delete
          info = {};
          info.text = cDelete;
          info.hasArrow = 1;
          UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
          -- Toon Tooltip Hide
          info = {};
          info.text = LB["TITAN_TREASURY_MENU_HIDETOON"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
          return;
     end
     if ( UIDROPDOWNMENU_MENU_LEVEL == 3 ) then
	  if ( UIDROPDOWNMENU_MENU_VALUE == cDelete ) then
               -- Delete Toon Data
               local dTable = TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ];
               table.foreach( dTable, function( Key, Data )
                         if ( Key ~= UnitName( "player" ) ) then
                              info = {};
                              info.text = TitanTreasury_ColorUtils( "GetCClass", Data.Class, Key );
                              info.func = function()
                                   TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ][ Key ] = nil;
                              end;
                              UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
                         end
                    end
               );
               TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL );
               -- Clears All Data
               info = {};
               info.text = LB["TITAN_TREASURY_MENU_CLEARALL"];
               info.func = function()
                    TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ] = {};
               end;
               info.value = LB["TITAN_TREASURY_MENU_CLEARALL"];
               UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
          end
          -- Hide Toon From Tooltip
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_TREASURY_MENU_HIDETOON"] ) then
               local dTable = TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ];
               local tHide = 0;
               table.foreach( dTable, function( Key, Data )
                         if ( Key ~= UnitName( "player" ) ) then
                              info = {};
                              info.text = TitanTreasury_ColorUtils( "GetCClass", Data.Class, Key );
                              info.func = function()
                                   TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ][ Key ].Hide = not Data.Hide;
                                   TitanPanelButton_UpdateButton( LB["TITAN_TREASURY_CORE_ID"] );
                              end;
                              info.checked = Data.Hide;
                              UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
                              if ( Data.Hide ) then tHide = tHide + 1; end
                         end
                    end
               );
               -- Show All Toons
               if ( tHide > 0 ) then
                    TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL );
                    info = {};
                    info.text = LB["TITAN_TREASURY_MENU_SHOWALL"];
                    info.func = function()
                         local dTable = TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ];
                         table.foreach( dTable, function( Key, Data )
                                   if ( Data.Hide ) then
                                        TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ][ Key ].Hide = not Data.Hide;
                                   end;
                              end
                         );
                         TitanPanelButton_UpdateButton( LB["TITAN_TREASURY_CORE_ID"] );
                    end;
                    info.value = LB["TITAN_TREASURY_MENU_SHOWALL"];
                    UIDropDownMenu_AddButton( info, UIDROPDOWNMENU_MENU_LEVEL );
               end
          end
	  return;
     end
     -- Tooltip Menu Title
     TitanPanelRightClickMenu_AddTitle( TitanPlugins[ LB["TITAN_TREASURY_CORE_ID"] ].menuText );
     -- Realm Menu
     info = {};
     info.text = cRealm;
     info.hasArrow = 1;
     UIDropDownMenu_AddButton( info );
     TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL );
     -- Settings MEnu
     info = {};
     info.text = LB["TITAN_TREASURY_MENU_SETTINGS"];
     info.func = function() InterfaceOptionsFrame_OpenToCategory( LB["TITAN_TREASURY_CONFIG"] ); end
     UIDropDownMenu_AddButton( info );
     TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL );
     -- Standard Menu
     TitanPanelRightClickMenu_AddToggleIcon( LB["TITAN_TREASURY_CORE_ID"] );
     TitanPanelRightClickMenu_AddToggleLabelText( LB["TITAN_TREASURY_CORE_ID"] );
     TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL );
     TitanPanelRightClickMenu_AddCommand( LB["TITAN_TREASURY_MENU_HIDE"], LB["TITAN_TREASURY_CORE_ID"], TITAN_PANEL_MENU_FUNC_HIDE );
     -- Custom Menu
     TitanPanelRightClickMenu_AddSpacer( UIDROPDOWNMENU_MENU_LEVEL );
     TitanPanelRightClickMenu_AddCommand( LB["TITAN_TREASURY_MENU_CLOSE"], LB["TITAN_TREASURY_CORE_ID"], function() return; end );
end