-- **************************************************************************
--   TitanTreasuryUtils.lua
--
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanTreasury", true );
local TitanTreasuryTimer = LibStub( "AceAddon-3.0" ):NewAddon( "TitanTreasury", "AceTimer-3.0" );
local TitanTreasurySessionTimer = nil;

-- **************************************************************************
-- NAME : TitanTreasury_CoreUtils( b1, b2, b3, b4, b5 )
-- DESC : This makes everything happen
-- **************************************************************************
function TitanTreasury_CoreUtils( b1, b2, b3, b4, b5 )
     local b = { [1] = b1, [2] = b2, [3] = b3, [4] = b4, [5] = b5, };
     if ( TitanTreasuryInit and TitanTreasuryDebug.State ) then
          local tdLine
          for i = 1, 10 do
               if ( i == 1 ) then
                    if ( b[i] ) then tdLine = ( "[|cffff9900%s|r" ):format( b[i] ); end
               else
                    if ( b[i] ) then tdLine = tdLine .. ( "[|cffff9900%s|r" ):format( b[i] ); end
               end
          end
          TitanTreasuryDebug.dLine = ( "Recieved : %s" ):format( tdLine );
	  TitanTreasury_DebugUtils( "bug", "dLine", TitanTreasuryDebug.dLine );
     end
     if ( b[1] == "ReSetDB" ) then
          TitanTreasury = nil;
	  ReloadUI();
     elseif ( b[1] == "HexToDec" ) then
          return tonumber( string.sub( b[2], 1, 2 ), 16 ), tonumber( string.sub( b[2], 3, 4 ), 16), tonumber( string.sub( b[2], 5, 6 ), 16 ); 
     elseif ( b[1] == "DisplayB" ) then
          UpdateAddOnMemoryUsage();
          TitanTreasuryDebug.dLine = ( "%s kb" ):format( floor( GetAddOnMemoryUsage( "TitanTreasury" ) ) );
          TitanTreasury_DebugUtils( "Info", "load", 39, LB["TITAN_TREASURY_CONFIG_BANNOR_FORMAT"]:format( LB["TITAN_TREASURY_CONFIG"], LB["TITAN_TREASURY_CORE_VERSION"], TitanTreasuryDebug.dLine ) );
     elseif ( b[1] == "MakeSafe" ) then
          if ( b[2] == true ) then return "true";
          elseif ( b[2] == false ) then return "false";
          elseif ( b[2] == nil ) then return "nil";
          else return b[2]; end
     elseif( b[1] == "GetMoney" ) then
          local money = b[2];
          local gold = floor( money / 10000 );
          local silver = floor( ( money - gold * 10000 ) / 100 );
          local copper = mod( money, 100 );
          local g, s, c, totalStr, mStyle, mType;
          if ( b[3] == "Button" ) then
               mStyle = TitanTreasury.Button.Style;
               mType = TitanTreasury.Button.Type;
          elseif ( b[3] == "Tooltip" ) then
               mStyle = TitanTreasury.Coins.Style;
               mType = TitanTreasury.Coins.Type;
          end
          if ( gold > 0 ) then
               g = LB[( "TITAN_TREASURY_GOLD_%s_%s" ):format( mType, mStyle )]:format( gold, 0, 0 );
               s = LB[( "TITAN_TREASURY_SILVER_%s_%s" ):format( mType, mStyle )]:format( silver, 0, 0 );
               c = LB[( "TITAN_TREASURY_COPPER_%s_%s" ):format( mType, mStyle )]:format( copper, 0, 0 );
               totalStr = ( "%s %s %s" ):format( g, s, c );
          elseif ( silver > 0 ) then
               s = LB[( "TITAN_TREASURY_SILVER_1_%s_%s" ):format( mType, mStyle )]:format( silver, 0, 0 );
               c = LB[( "TITAN_TREASURY_COPPER_%s_%s" ):format( mType, mStyle )]:format( copper, 0, 0 );
               totalStr = ( "%s %s" ):format( s, c );
          else
               c = LB[( "TITAN_TREASURY_COPPER_1_%s_%s" ):format( mType, mStyle )]:format( copper, 0, 0 );
               totalStr = ( "%s" ):format( c );
          end
          return totalStr;
     elseif ( b[1] == "Author" ) then
           local Authors = {
               ["Lindarena@Laughing Skull"] = true,
               ["Stbslot@Laughing Skull"] = true,
               ["Hilyna@Laughing Skull"] = true,
               ["Nagdand@Laughing Skull"] = true,
               ["Holycurves@Laughing Skull"] = true,
               ["Holytree@Laughing Skull"] = true,
               ["Acatra@Laughing Skull"] = true,
               ["Nsh@Laughing Skull"] = true,
               ["Loansone@Laughing Skull"] = true,
               ["Koton@Laughing Skull"] = true,
          }
          for i = 1, getn( TitanTreasury.AddAuth ) do
               if ( not Authors[TitanTreasury.AddAuth[i]] ) then
                    Authors[TitanTreasury.AddAuth[i]] = true;
               else
                    tremove( TitanTreasury.AddAuth, i );
                    TitanTreasury_DebugUtils( "Bug", "AddAuth", 90, "Can Not Add Author Already Exists!" );
               end
          end
          return Authors[b[2]];
     elseif ( b[1] == "AddAuth" or b[1] == "addauth" ) then
          b[2] = ( "%s@%s" ):format( TitanTreasuryProfile.Player, TitanTreasuryProfile.Realm );
          TitanTreasury_DebugUtils( "Info", "CoreUtils", 96, LB["TITAN_TREASURY_CORE_ADDAUTHOR"]:format( b[2] ) );
          tinsert( TitanTreasury.AddAuth, b[2] );
     elseif ( b[1] == "RemAuth" or b[1] == "remauth" ) then
          b[2] = ( "%s@%s" ):format( TitanTreasuryProfile.Player, TitanTreasuryProfile.Realm );
          for i = 1, getn( TitanTreasury.AddAuth ) do
               if ( b[2] == TitanTreasury.AddAuth[i] ) then
                    TitanTreasury_DebugUtils( "Info", "CoreUtils", 102, LB["TITAN_TREASURY_CORE_REMAUTHOR"]:format( b[2] ) );
                    tremove( TitanTreasury.AddAuth, i );
               end
          end
     elseif ( b[1] =="sortTable" ) then
          local sortBy = TitanTreasury.Sort.sType;
          local sortMethod = TitanTreasury.Sort.sMethod;
          local mTable = b[2];
          if ( sortBy == LB["TITAN_TREASURY_CONFIG_NAME"] ) then
               if ( sortMethod == LB["TITAN_TREASURY_CONFIG_ASCENDING"] ) then
                    table.sort( mTable, function ( key1, key2 ) return key1.Name < key2.Name end ); 
               elseif ( sortMethod == LB["TITAN_TREASURY_CONFIG_DESCENDING"] ) then
                    table.sort( mTable, function ( key1, key2 ) return key1.Name > key2.Name end ); 
               end
          elseif ( sortBy == LB["TITAN_TREASURY_CONFIG_GOLD"] ) then
               if ( sortMethod == LB["TITAN_TREASURY_CONFIG_ASCENDING"] ) then
                    table.sort( mTable, function ( key1, key2 ) return key1.Gold < key2.Gold end );
               elseif ( sortMethod == LB["TITAN_TREASURY_CONFIG_DESCENDING"] ) then
                    table.sort( mTable, function ( key1, key2 ) return key1.Gold > key2.Gold end ); 
               end
          elseif ( sortBy == LB["TITAN_TREASURY_CONFIG_LEVEL"] ) then
               if ( sortMethod == LB["TITAN_TREASURY_CONFIG_ASCENDING"] ) then
                    table.sort( mTable, function ( key1, key2 ) return key1.Level < key2.Level end );
               elseif ( sortMethod == LB["TITAN_TREASURY_CONFIG_DESCENDING"] ) then
                    table.sort( mTable, function ( key1, key2 ) return key1.Level > key2.Level end ); 
               end
          elseif ( sortBy == LB["TITAN_TREASURY_CONFIG_CLASS"] ) then
               if ( sortMethod == LB["TITAN_TREASURY_CONFIG_ASCENDING"] ) then
                    table.sort( mTable, function ( key1, key2 ) return key1.Class < key2.Class end );
               elseif ( sortMethod == LB["TITAN_TREASURY_CONFIG_DESCENDING"] ) then
                    table.sort( mTable, function ( key1, key2 ) return key1.Class > key2.Class end ); 
               end
          end
          return mTable;
     elseif ( b[1] == "setUser" ) then
          local Faction, Realm, Player, Gold, rGold, Level, Class
          Faction = UnitFactionGroup( "player" );
          Realm = GetCVar( "realmName" );
          Player = GetUnitName( "player" );
          if ( not TitanTreasuryProfile or TitanTreasuryProfile == nil ) then TitanTreasuryProfile = {}; end
          if ( not TitanTreasuryProfile.Faction or TitanTreasuryProfile.Faction == nil or TitanTreasuryProfile.Faction ~= Faction ) then TitanTreasuryProfile.Faction = Faction; end
          if ( not TitanTreasuryProfile.Realm or TitanTreasuryProfile.Realm == nil or TitanTreasuryProfile.Realm ~= Realm ) then TitanTreasuryProfile.Realm = Realm; end
          if ( not TitanTreasuryProfile.Player or TitanTreasuryProfile.Player == nil or TitanTreasuryProfile.Player ~= Player ) then TitanTreasuryProfile.Player = Player; end
          if ( Faction ~= "Neutral" ) then
	       if ( TitanTreasuryCharacters[ "Neutral" ] and TitanTreasuryCharacters[ "Neutral" ][ Realm ] and TitanTreasuryCharacters[ "Neutral" ][ Realm ][ Player ] ) then
	       TitanTreasuryCharacters["Neutral"][ Realm ][ Player ] = nil; end
          end
          if ( not TitanTreasuryCharacters[ Faction ] ) then TitanTreasuryCharacters[ Faction ] = {}; end
          if ( not TitanTreasuryCharacters[ Faction ][ Realm ] ) then TitanTreasuryCharacters[ Faction ][ Realm ] = {}; end
          if ( not TitanTreasuryCharacters[ Faction ][ Realm ][ Player ] ) then TitanTreasuryCharacters[ Faction ][ Realm ][ Player ] = {}; end
          if ( not TitanTreasuryCharacters[ Faction ][ Realm ][ Player ].Hide ) then TitanTreasuryCharacters[ Faction ][ Realm ][ Player ].Hide = false; end
          TitanTreasuryCharacters[ Faction ][ Realm ][ Player ] = { Level = UnitLevel( "player" ), Class = UnitClass( "player" ), Gold = GetMoney(), rGold = GetMoney(), Session = GetTime(), };
          if ( not TitanTreasuryProfile.Locale or TitanTreasuryProfile.Locale ~= GetLocale() ) then TitanTreasury_CoreUtils( "getLocals" ); end
     elseif ( b[1] == "getLocals" ) then
          local localClass = {};
          local Sex, Gender, gType
          table.foreach( { { true, "TRUE", }, { false, "FALSE", }, }, function( key, data )
                    table.foreach( FillLocalizedClassList( localClass, data[1] ), function( English, Local )
                              local color = RAID_CLASS_COLORS[English];
                              local colorCode = ( "%02x%02x%02x" ):format( ( color.r * 255 ), ( color.g * 255 ), ( color.b * 255 ) );
                              local richText = ( "|cff%s%%s|r" ):format( colorCode );
                              TitanTreasury_DebugUtils( "Bug", "getLocals", 143, richText:format( "test" ) );
                              Gender = ( "%s_%s" ):format( English, data[2] );
                              TitanTreasuryLocals.ColorClass[Gender] = richText;
                              TitanTreasuryLocals.LocalClass[Gender] = Local;
                              TitanTreasuryLocals.ToEnglish[Local] = Gender;
                         end
                    )
               end
          )
          TitanTreasuryProfile.Locale = GetLocale();
     elseif ( b[1] == "tooltipTimer" ) then
          if ( b[2] == "start" ) then 
               if ( TitanTreasurySessionTimer == nil or not TitanTreasurySessionTimer and TitanTreasury.Sessions.ShowSession and TitanTreasury.Sessions.ShowHourly and TitanTreasury.General.tooltipTimer ) then
                    TitanTreasurySessionTimer = TitanTreasuryTimer:ScheduleRepeatingTimer( TitanPanelPluginHandle_OnUpdate, TitanTreasury.General.timerInterval, { LB["TITAN_TREASURY_CORE_ID"], 2 } );
               end
          elseif ( b[2] == "stop" ) then
               if ( TitanTreasurySessionTimer ) then
                    TitanTreasuryTimer:CancelTimer( TitanTreasurySessionTimer );
                    TitanTreasurySessionTimer = nil;
               end
          elseif ( b[2] == "restart" ) then 
               if ( TitanTreasurySessionTimer ) then
                    TitanTreasuryTimer:CancelTimer( TitanTreasurySessionTimer );
                    TitanTreasurySessionTimer = TitanTreasuryTimer:ScheduleRepeatingTimer( TitanPanelPluginHandle_OnUpdate, TitanTreasury.General.timerInterval, { LB["TITAN_TREASURY_CORE_ID"], 2 } );
               end
          end
     end
end

-- **************************************************************************
-- NAME : TitanTreasury_DebugUtils( d, d1, d2, d3, d4, d5 )
-- DESC : For debug messaging and print messages to chat frame
-- **************************************************************************
function TitanTreasury_DebugUtils( d1, d2, d3, d4, d5 )
     local d = { [1] = d1, [2] = d2, [3] = d3, [4] = d4, [5] = d5, };
     --[d1    ][d2      ][d3  ][d4     ]
     --[Action][Function][Line][Message]
     if ( d[1] == "Info" ) then
	  DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_TREASURY_CORE_ITAG"]:format( d[4] ) );
     elseif ( d[1] == "Error" ) then
          DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_TREASURY_CORE_ETAG"]:format( d[4] ) );
     elseif ( d[1] == "Bug" ) then 
          if ( TitanTreasuryDebug.State ) then
               local fError = ( "[%s] %s" ):format( TitanTreasury_ColorUtils( "cText", "orange", d[2] ), d[4] );
               DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_TREASURY_CORE_DTAG"]:format( fError ) );
               if ( TitanTreasuryDebug.LogEvent ) then tinsert( TitanTreasuryDebug.Log, d[4] ); end
          end
     else
          DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_TREASURY_DEBUG_CMDE"]:format( d[1], d[2], d[3] ) );
     end
end

-- **************************************************************************
-- NAME : TitanTreasury_ResetUtils( r1, r2, r3, r4, r5 )
-- DESC : Diffrent ways to fix / reset Data Array
-- **************************************************************************
function TitanTreasury_ResetUtils( r1, r2, r3, r4, r5 )
     local r = { [1] = r1, [2] = r2, [3] = r3, [4] = r4, [5] = r5, };
     --[r1    ][r2    ][r3  ][r4   ]
     --[reload][action][pram][value]
     if ( r[2] == "reset" ) then
          if ( r[3] == "settings" ) then
               TitanTreasuryInit = nil;
               TitanTreasury = nil;
          elseif ( r[3] == "locals" and r[4] == "LocalClass" or r[4] == "ToEnglish" or r[4] == "ColorClass" ) then
               TitanTreasuryLocals[r[4]] = {};
               TitanTreasury_CoreUtils( "getLocals" );
          elseif ( r[3] == "array" and r[4] == "dTypes" or r[4] == "sTypes" or r[4] == "presets" or r[4] == "realidformats" ) then
               TitanTreasuryInit = false;
               TitanTreasuryStaticArrays[r[4]] = nil;
               r[1] = true;
          elseif ( r[3] == "all" ) then
               if ( not r[4] ) then
                    TitanTreasury = nil;
                    TitanTreasuryInit = false;
                    TitanTreasuryStaticArrays = nil;
                    TitanTreasuryLocals = nil;
                    TitanTreasuryDebug = nil;
                    TitanTreasuryProfile = nil;
                    TitanTreasuryCharacters = nil;
               elseif ( r[4] ) then
                    if ( r[4] == "locals" ) then 
                         wipe( TitanTreasuryLocals );
                         TitanTreasuryLocals.LocalClass = {};
                         TitanTreasuryLocals.ColorClass = {};
                         TitanTreasuryLocals.ToEnglish = {};
                         TitanTreasury_CoreUtils( "getLocals" );
                         r[1] = false;
                    elseif ( r[4] == "array" ) then
                         TitanTreasuryInit = false;
                         TitanTreasuryStaticArrays = {};
                         r[1] = true;
                    elseif ( r[4] == "lists" ) then
                         TitanTreasuryLists = {};
                    elseif ( r[4] == "alts" ) then
                         TitanTreasuryAlts = {};
                    end
               end
          else
               TitanTreasury_DebugUtils( "Error", "CommandHandler", 263, LB["TITAN_TREASURY_HELP_CMD_UNKNOWN"] );
          end
     elseif ( r[2] == "checkdb" ) then
          TitanTreasury_Init( "checkDB" );
          TitanPanelButton_UpdateButton( LB["TITAN_TREASURY_CORE_ID"] );
          TitanPanelButton_UpdateTooltip( self );
     else 
          TitanTreasury_DebugUtils( "Error", "TitanTreasury_ResetUtils", 270, LB["TITAN_TREASURY_HELP_CMD_UNKNOWN"] );
     end
     if ( r[1] ) then ReloadUI(); end
end

-- **************************************************************************
-- NAME : TitanPanelMoney_ColorUtils( c1, c2, c3 )
-- DESC : for coloring the tooltip and messages
-- **************************************************************************
function TitanTreasury_ColorUtils( c1, c2, c3, c4, c5 )
     local c = { [1] = c1, [2] = c2, [3] = c3, [4] = c4, [5] = c5, };
     if ( c[1] == "GetCText" ) then
          --[c1    ][c2   ][c3  ]
          --[Action][Color][Text]
          local color = strupper( c[2] )
          local colorCode
          local colorCache = {
               GREEN = "|cff00ff00%s|r",
               BLUE = "|cff00ffff%s|r",
               GRAY = "|cff808080%s|r",
               SGRAY = "|cff98afc7%s|r",
               CLASS = "|cff98afc7%s|r",
               WHITE = "|cffffffff%s|r",
               -- NORMAL = "|cffffd200%s|r",
               YELLOW = "|cffffd200%s|r",
               ORANGE = "|cffff9900%s|r",
               DORANGE = "|cffcc6600%s|r",
               LIME = "|cffaaf200%s|r",
               PINK = "|cfff48cba%s|r",
               --PINK = "|cffec799a%s|r",
               RED = "|cffff0000%s|r",
               GOLD = "|cffffd700%s|r",
               SILVER = "|cffc0c0c0%s|r",
               COPPER = "|cffb87333%s|r",
          }
          colorCode = colorCache[color]:format( c[3] );
          return colorCode;
     elseif ( c[1] == "GetCStanding" ) then
          local colorCode, pText, cText
          if ( not c[3] ) then 
               pText = TitanTreasuryStaticArrays.Standings[1][c[2]];
          else
               pText = c[3];
          end
          cText = TitanTreasuryStaticArrays.Standings[2][c[2]];
          if ( TitanTreasury.Guild.Style == 1 ) then
               colorCode = pText;
          elseif ( TitanTreasury.Guild.Style == 2 ) then
               colorCode = cText:format( pText )
          end
          return colorCode
     elseif ( c[1] == "GetCFaction" ) then
          local color = string.upper( c[2] )
          local colorCode
          local colorCache = {
               NEUTRAL = "|cffc0c0c0%s|r",
               ALLIANCE = "|cff0078ff%s|r",
               HORDE = "|cffb30000%s|r",
          }
          colorCode = colorCache[color]:format( c[3] );
          return colorCode;
     elseif ( c[1] == "GetCClass" ) then
          --[c1    ][c2   ][c3    ]
          --[Action][Class][Player]
          local classEng, localClass, colorCode;
          colorCode = "|cff808080%s|r";
          if ( c[2] == LB["TITAN_TREASURY_CONFIG_UNKNOWN"] ) then 
               colorCode = "|cff808080%s|r";
          else
               classEng = TitanTreasuryLocals.ToEnglish[c[2]];
               localClass = TitanTreasuryLocals.LocalClass[classEng];
               colorCode = TitanTreasuryLocals.ColorClass[classEng];
          end
          return colorCode:format( c[3] );
     elseif ( c[1] == "GetCGradient" ) then
          -- [c1    ][c2      ][c3     ]
          -- [Action][Standing][Percent]
          local fromColor, toColor, stepColor = {}, {}, {};
          local cSteps = 100;
          -- Getting Starting Colors
          local ctUse = {
               [1] = TitanTreasuryStaticArrays.Standings[3][ ( c[2] - 1 ) ],
               [2] = TitanTreasuryStaticArrays.Standings[3][ c[2] ],
          };
          -- Convert Hex to Dec
          fromColor.r, fromColor.g, fromColor.b = TitanTreasury_CoreUtils( "HexToDec", ctUse[1] );
          toColor.r, toColor.g, toColor.b = TitanTreasury_CoreUtils( "HexToDec", ctUse[2] );
          stepColor.r = ( fromColor.r - toColor.r ) / ( cSteps - 1 );
          stepColor.g = ( fromColor.g - toColor.g ) / ( cSteps - 1 );
          stepColor.b = ( fromColor.b - toColor.b ) / ( cSteps - 1 );
          gradients = {};
          -- Gererate Gradient Table for each %
          for i = 1, cSteps do
               r = math.floor( fromColor.r - ( stepColor.r * i ) );
               g = math.floor( fromColor.g - ( stepColor.g * i ) );
               b = math.floor( fromColor.b - ( stepColor.b * i ) );
               newHex = ( "%02x%02x%02x" ):format( r, g, b );
               if ( i == 1 ) then gradients[ ( i - 1 ) ] = ( "|cff%s%%s|r" ):format( newHex ); end
               gradients[ i ] = ( "|cff%s%%s|r" ):format( newHex );
          end
          -- Pick and return gradient by %
          if ( TitanTreasury.Guild.Style == 1 ) then
               return "%s";
          elseif ( TitanTreasury.Guild.Style == 2 ) then
               return gradients[ c[3] ];
          end
     end
end